
require(tidyverse)
require(tidyr)

# File containing desired samples, generated at the 1000 Genomes Project web:
index1000 <- read.delim("./1000genomeslist.txt",header=T)
index1000$Sample.name <- as.character(index1000$Sample.name)


# Dowload of download links from the 1000 Genomes Server:
index1000lowcov <- read.delim("ftp://ftp.1000genomes.ebi.ac.uk/vol1/ftp/phase3/20130502.phase3.low_coverage.alignment.index", header=T)
index1000lowcov <- index1000lowcov[seq(3,nrow(index1000lowcov), by=4),]
index1000lowcov$BAM.FILE <- as.character(index1000lowcov$BAM.FILE)


indexsep1 <- separate(index1000lowcov,1,c("a","b","c","d"),sep="/")
indexsep2 <- separate(indexsep1,4,c("e","f","g","h","i"),sep="\\.")

index1000lowcov$SAMPLE <- indexsep2$e
index1000lowcov$POPULATION <- indexsep2$i
index1000lowcov$FILE <- indexsep1[,4]

index1000analysis <- merge(index1000, index1000lowcov, by.x="Sample.name", by.y="SAMPLE")
index1000analysis



malesindex1000analysis <- index1000analysis[as.character(index1000analysis$Sex)=="male",]
malesindex1000analysis


# Preparing input for bash script:

index1000genomes <- cbind(paste("ftp://ftp.1000genomes.ebi.ac.uk/vol1/ftp/phase3/",index1000analysis$BAM.FILE, sep=""), index1000analysis$Sample.name, index1000analysis$Sex, index1000analysis$Population.code, index1000analysis$Superpopulation.code)
write.table(index1000genomes, sep=",", file="./1000genomesindex.txt", quote=FALSE, row.names = F, col.names = F)

