
defac = function(x) {as.numeric(as.character(x))}

require(ggplot2)
require(HardyWeinberg)


################################# ANALYSIS OF HSA NUMTS #################################
indexfiles = list.files("/Users/Luis/analysis/workingdirPHASE2/results")

population.freq.table=list()
totaltable=cbind(index1000genomes[,2], index1000genomes[,4])
counter=0
numttablepoly=list()

# NUMTs 
for (i in c(2,7,10,18,28,30,39)) {
  
  counter=counter+1
  numttablepoly[[counter]] = read.csv(file=paste("/Users/Luis/analysis/workingdirPHASE2/results/", indexfiles[i], sep=""), sep="\t", header=F, fill=T)
  numttablepoly[[counter]] = numttablepoly[[counter]][-1,]
  population.freq.table[[counter]]=matrix(data = NA, nrow=27, ncol=8)
  
  if ( ( 1 %in% numttablepoly[[counter]][,2]) == FALSE ) {
    print(table(numttablepoly[[counter]][,2]))
  
  heteralign = rep(NA, nrow(numttablepoly[[counter]]))
  heteralign[which(defac(numttablepoly[[counter]]$V8)!=0 & defac(numttablepoly[[counter]]$V9)!=0)] = "DI"
  heteralign[which((defac(numttablepoly[[counter]]$V4)!=0 | defac(numttablepoly[[counter]]$V5)!=0) & is.na(heteralign)==T)] = "II"
  heteralign[which(is.na(heteralign)==T)] = "DD"
  
  numttablepoly[[counter]]=cbind(numttablepoly[[counter]], heteralign)
  
  numttablepoly[[counter]]$V7 = defac(numttablepoly[[counter]]$V7)
  boxplotcov[[counter]] = ggplot(numttablepoly[[counter]], aes(x=heteralign, y=V7, colour=heteralign)) +
    geom_boxplot() +
    coord_flip() +
    ggtitle(paste("Diagnostic plot for ", gsub(".txt", "", indexfiles[i]), sep="") ) +
    ylab("Coverage NUMT / Coverage flanking region") +
    xlab("Defined genotype") + 
    theme(legend.title = element_blank())

  print(boxplotcov[[counter]])
  ggsave(plot=boxplotcov[[counter]], filename = paste("./diagnosticplotsHSA/diagplot", gsub(".txt", "", indexfiles[i]), ".png", sep="") )
  
  numttablepoly[[counter]]$V3 = defac(numttablepoly[[counter]]$V3)
  numttablepoly[[counter]]$V6 = defac(numttablepoly[[counter]]$V6)
  
  numttablepoly[[counter]] = cbind(numttablepoly[[counter]], index1000genomes[,4])
  numttablepoly[[counter]] = cbind(numttablepoly[[counter]], index1000genomes[,5])
  colnames(numttablepoly[[counter]])[15]="pob"
  
  counterhet=0
  counterpob=0
  X=matrix(NA, nrow=26, ncol=3)
  rownames(X) = unique(index1000genomes[,4]) 
  colnames(X) = c("DD", "DI", "II")
  for (k in c("DD", "DI", "II")) {
    counterhet=counterhet+1
    counterpob=0
    for (j in c(unique(index1000genomes[,4]))) {
      counterpob=counterpob+1
        X[counterpob, counterhet] = length( which(numttablepoly[[counter]]$heteralign == k & numttablepoly[[counter]]$pob==j) )
      
    }
      
  }
  
  X=rbind(colSums(X), X)
  rownames(X)[1] = "Total"
  
  population.freq.table[[counter]][,1] = gsub(".txt", "", indexfiles[i])
  population.freq.table[[counter]][,2] = c("-", superpopnames[vectorpopsuperpop])
  population.freq.table[[counter]][,3] = rownames(X)
  population.freq.table[[counter]][,4] = rowSums(X)
  population.freq.table[[counter]][,5] = X[,1]
  population.freq.table[[counter]][,6] = X[,2]
  population.freq.table[[counter]][,7] = X[,3]
  population.freq.table[[counter]][,8] = HWExactMat(X)$pvalvec
  totaltable=cbind(totaltable, as.character(numttablepoly[[counter]]$heteralign))
  
  
  }
}


# Numt 474
for (i in 33) {

  numttablepoly[[8]] = read.csv(file=paste("/Users/Luis/analysis/workingdirPHASE2/results/", indexfiles[i], sep=""), sep="\t", header=F, fill=T)
  numttablepoly[[8]] = numttablepoly[[8]][-1,]
  
    population.freq.table[[length(population.freq.table)+1]]=matrix(data = NA, nrow=27, ncol=8)
    
    heteralign = rep(NA, nrow(numttablepoly[[8]]))
    heteralign[which( (defac(numttablepoly[[8]]$V4)!=0  | defac(numttablepoly[[8]]$V6)!=0 | defac(numttablepoly[[8]]$V7)!=0)
                     & (defac(numttablepoly[[8]]$V8)!=0 | defac(numttablepoly[[8]]$V9)!=0 ) )] = "DI"
    heteralign[which( (defac(numttablepoly[[8]]$V4)==0  & defac(numttablepoly[[8]]$V6)==0 & defac(numttablepoly[[8]]$V7)==0)
                     & (defac(numttablepoly[[8]]$V8)!=0 | defac(numttablepoly[[8]]$V9)!=0 ) )] = "DD"
    heteralign[which( (defac(numttablepoly[[8]]$V4)!=0  | defac(numttablepoly[[8]]$V6)!=0 | defac(numttablepoly[[8]]$V7)!=0)
                     & (defac(numttablepoly[[8]]$V8)==0 & defac(numttablepoly[[8]]$V9)==0 ) )] = "II"
    
    
    numttablepoly[[8]]=cbind(numttablepoly[[8]], heteralign)
    
    
    numttablepoly[[8]] = cbind(numttablepoly[[8]], index1000genomes[,4])
    numttablepoly[[8]] = cbind(numttablepoly[[8]], index1000genomes[,5])
    colnames(numttablepoly[[8]])[17]="pob"
    
    counterhet=0
    counterpob=0
    X=matrix(NA, nrow=26, ncol=3)
    rownames(X) = unique(index1000genomes[,4]) 
    colnames(X) = c("DD", "DI", "II")
    for (k in c("DD", "DI", "II")) {
      counterhet=counterhet+1
      counterpob=0
      for (j in c(unique(index1000genomes[,4]))) {
        counterpob=counterpob+1
        X[counterpob, counterhet] = length( which(numttablepoly[[8]]$heteralign == k & numttablepoly[[8]]$pob==j) )
        
      }
      
    }

    X=rbind(colSums(X), X)
    rownames(X)[1] = "Total"
    
    population.freq.table[[length(population.freq.table)]][,1] = gsub(".txt", "", indexfiles[i])
    population.freq.table[[length(population.freq.table)]][,2] = c("-", superpopnames[vectorpopsuperpop])
    population.freq.table[[length(population.freq.table)]][,3] = rownames(X)
    population.freq.table[[length(population.freq.table)]][,4] = rowSums(X)
    population.freq.table[[length(population.freq.table)]][,5] = X[,1]
    population.freq.table[[length(population.freq.table)]][,6] = X[,2]
    population.freq.table[[length(population.freq.table)]][,7] = X[,3]
    population.freq.table[[length(population.freq.table)]][,8] = HWExactMat(X)$pvalvec
    totaltable=cbind(totaltable, as.character(numttablepoly[[counter]]$heteralign))
    
    totaltable=cbind(totaltable, as.character(numttablepoly[[8]]$heteralign))
}


# Numt 522
for (i in 38) { 
  
  numttablepoly[[9]] = read.csv(file=paste("/Users/Luis/analysis/workingdirPHASE2/results/", indexfiles[i], sep=""), sep="\t", header=F, fill=T)
  numttablepoly[[9]] = numttablepoly[[9]][-1,]
  
  population.freq.table[[length(population.freq.table)+1]]=matrix(data = NA, nrow=27, ncol=8)
  
  heteralign = rep(NA, nrow(numttablepoly[[9]]))
  
  for (l in 1:2535)
    {
    
    if ( defac(numttablepoly[[9]][l,2]) == 0) {
      if(defac(numttablepoly[[9]]$V8[l])!=0 & defac(numttablepoly[[9]]$V9[l])!=0)
      {heteralign[l]= "DI"}
      if((defac(numttablepoly[[9]]$V4[l])!=0 | defac(numttablepoly[[9]]$V5[l])!=0) & is.na(heteralign[l])==T)
                {heteralign[l] = "II"}
     if (is.na(heteralign[l])==T) {heteralign[l]= "DD"}
  }
  
  
  
  if ( defac(numttablepoly[[9]][l,2]) == 1) {
  
  if ( ( defac(numttablepoly[[9]]$V11[l])!=0 | defac(numttablepoly[[9]]$V9[l])!=0 | defac(numttablepoly[[9]]$V8[l])!=0 )
                    &
                      ( defac(numttablepoly[[9]]$V10[l])!=0 | defac(numttablepoly[[9]]$V7[l])!=0 | defac(numttablepoly[[9]]$V6[l])!=0 | defac(numttablepoly[[9]]$V5[l])!=0 | defac(numttablepoly[[9]]$V4[l])!=0 )
                    ) {heteralign[l] = "DI"}

  if ( ( defac(numttablepoly[[9]]$V11[l])==0 & defac(numttablepoly[[9]]$V9[l])==0 & defac(numttablepoly[[9]]$V8[l])==0 )
                    &
                      ( defac(numttablepoly[[9]]$V10[l])!=0 | defac(numttablepoly[[9]]$V7[l])!=0 | defac(numttablepoly[[9]]$V6[l])!=0 | defac(numttablepoly[[9]]$V5[l])!=0 | defac(numttablepoly[[9]]$V4[l])!=0 )
                    ) { heteralign[l] = "II"}
  
    if (is.na(heteralign[l])==T) {heteralign[l]="DD"}
  }
  
  }
  
  
  print(i)
  numttablepoly[[9]]=cbind(numttablepoly[[9]], heteralign)
  
  numttablepoly[[9]]$V7 = defac(numttablepoly[[9]]$V7)
  boxplotcov = ggplot(numttablepoly[[9]][which(defac(numttablepoly[[9]][,2]) == 0),], aes(x=heteralign, y=V7, colour=heteralign)) + geom_boxplot() + coord_flip()
  print(boxplotcov)
  
  numttablepoly[[9]] = cbind(numttablepoly[[9]], index1000genomes[,4])
  numttablepoly[[9]] = cbind(numttablepoly[[9]], index1000genomes[,5])
  colnames(numttablepoly[[9]])[17]="pob"
  
  counterhet=0
  counterpob=0
  X=matrix(NA, nrow=26, ncol=3)
  rownames(X) = unique(index1000genomes[,4]) 
  colnames(X) = c("DD", "DI", "II")
  for (k in c("DD", "DI", "II")) {
    counterhet=counterhet+1
    counterpob=0
    for (j in c(unique(index1000genomes[,4]))) {
      counterpob=counterpob+1
      X[counterpob, counterhet] = length( which(numttablepoly[[9]]$heteralign == k & numttablepoly[[9]]$pob==j) )
      
    }
    
  }

  X=rbind(colSums(X), X)
  rownames(X)[1] = "Total"

  
  population.freq.table[[length(population.freq.table)]][,1] = gsub(".txt", "", indexfiles[i])
  population.freq.table[[length(population.freq.table)]][,2] = c("-", superpopnames[vectorpopsuperpop])
  population.freq.table[[length(population.freq.table)]][,3] = rownames(X)
  population.freq.table[[length(population.freq.table)]][,4] = rowSums(X)
  population.freq.table[[length(population.freq.table)]][,5] = X[,1]
  population.freq.table[[length(population.freq.table)]][,6] = X[,2]
  population.freq.table[[length(population.freq.table)]][,7] = X[,3]
  population.freq.table[[length(population.freq.table)]][,8] = HWExactMat(X)$pvalvec
  totaltable=cbind(totaltable, as.character(numttablepoly[[counter]]$heteralign))
  
  totaltable=cbind(totaltable, as.character(numttablepoly[[9]]$heteralign))
}


population.freq.table.full = population.freq.table[[1]]
for (i in 2:length(population.freq.table)) {
  
  population.freq.table.full = rbind(population.freq.table.full, population.freq.table[[i]])
  
}
population.freq.table.full = data.frame(population.freq.table.full)


colnames(totaltable) = c("Individual", "Population", "HSA_NumtS_009", "HSA_NumtS_050",
                         "HSA_NumtS_133", "HSA_NumtS_214", "HSA_NumtS_426", "HSA_NumtS_460", "HSA_NumtS_543"
                         , "HSA_NumtS_474", "HSA_NumtS_522")


freqstable=matrix(NA, nrow=26, ncol=9)
rownames(freqstable) = unique(index1000genomes[,4]) 
counterpob=0
for (i in unique(index1000genomes[,4])) {
  counterpob=counterpob+1
  for (k in 3:11) {
    
    sumfreq=length(totaltable[which(totaltable[,2] == i & totaltable[,k] == "DI")])*0.5
    print(sumfreq)
    sumfreq=sumfreq+length(totaltable[which(totaltable[,2] == i & totaltable[,k] == "II")])
    print(sumfreq)
    sumfreq=sumfreq/length(totaltable[which(totaltable[,2] == i)])
    print(sumfreq)
    freqstable[counterpob,k-2]=sumfreq
  }

  
  
}


colnames(freqstable) = c("HSA_NumtS_009", "HSA_NumtS_050",
                         "HSA_NumtS_133", "HSA_NumtS_214", "HSA_NumtS_426", "HSA_NumtS_460", "HSA_NumtS_543"
                         , "HSA_NumtS_474", "HSA_NumtS_522")


require(FactoMineR)
PCA_HSA_NUMTS = PCA(freqstable)

superpopnames = c("EAS", "EUR",  "AFR", "AMR", "SAS")
vectorpopsuperpop = c(2,2,1,4,1,4,2,4,5,1,3,3,3,5,3,5,5,2,3,1,1,3,3,4,2,5)
plot(PCA_HSA_NUMTS, col.ind=vectorpopsuperpop, title = "PCA for HSA NUMTs")


################################# END ANALYSIS OF HSA NUMTS #################################






################################# ANALYSIS OF Poly NUMTS #################################

indexfilespoly = list.files("/Users/Luis/analysis/workingdirPHASE2/polyresults/")
polytotaltable=cbind(index1000genomes[,2], index1000genomes[,4])
numttablepoly=list()
population.freq.table.poly = list()
X = list()
dotplot = list()

for (i in 1:length(indexfilespoly)) {
  
  numtspaper2014[[i]] = read.csv(file=paste("/Users/Luis/analysis/workingdirPHASE2/polyresults/", indexfilespoly[i], sep=""), sep="\t", header=F, fill=T)
  numtspaper2014[[i]] = numtspaper2014[[i]][-1,]
  
  population.freq.table.poly[[i]]=matrix(data = NA, nrow=27, ncol=8)
  
  heteralign = rep(NA, nrow(numtspaper2014[[i]]))
  heteralign[which( defac(numtspaper2014[[i]]$V20)==0 & defac(numtspaper2014[[i]]$V15)==0 & defac(numtspaper2014[[i]]$V16)==0 & defac(numtspaper2014[[i]]$V13)!=0 ) ] = "DD"
  heteralign[which( (defac(numtspaper2014[[i]]$V20)!=0 | defac(numtspaper2014[[i]]$V15)!=0 | defac(numtspaper2014[[i]]$V16)!=0)
                    &  defac(numtspaper2014[[i]]$V3)!=0 ) ] = "DI"
  heteralign[which( (defac(numtspaper2014[[i]]$V20)!=0 | defac(numtspaper2014[[i]]$V15)!=0 | defac(numtspaper2014[[i]]$V16)!=0)
                    &  defac(numtspaper2014[[i]]$V3)==0 )] = "II"
  
  
  numtspaper2014[[i]]=cbind(numtspaper2014[[i]], heteralign)

  numtspaper2014[[i]]$V2 = defac(numtspaper2014[[i]]$V2)
  numtspaper2014[[i]]$V3 = defac(numtspaper2014[[i]]$V3)
  
  dotplot[[i]] = ggplot(numtspaper2014[[i]], aes(x=V2, y=V3, colour=heteralign)) +
    geom_point() +
    ggtitle(paste("Diagnostic plot for ", gsub(".txt", "", indexfilespoly[i]), sep="") ) +
    ylab("Reads supporting deletion") +
    xlab("Flanking coverage") + 
    labs(colour="Defined genotype")
  
  print(dotplot[[i]])
  ggsave(plot=dotplot[[i]], filename = paste("./diagnosticplotsPOLY/diagplot", gsub(".txt", "", indexfilespoly[i]), ".png", sep="") )
  
    
  numtspaper2014[[i]] = cbind(numtspaper2014[[i]], index1000genomes[,4])
  numtspaper2014[[i]] = cbind(numtspaper2014[[i]], index1000genomes[,5])
  colnames(numtspaper2014[[i]])[22]="pob"
  
  counterhet=0
  counterpob=0
  X=matrix(NA, nrow=26, ncol=3)
  rownames(X) = unique(index1000genomes[,4]) 
  colnames(X) = c("DD", "DI", "II")
  for (k in c("DD", "DI", "II")) {
    counterhet=counterhet+1
    counterpob=0
    for (j in c(unique(index1000genomes[,4]))) {
      counterpob=counterpob+1
      X[counterpob, counterhet] = length( which(numtspaper2014[[i]]$heteralign == k & numtspaper2014[[i]]$pob==j) )
      
    }
    
  }
  
  X=rbind(colSums(X), X)
  rownames(X)[1] = "Total"
  
  print(X)
  
  population.freq.table.poly[[i]][,1] = gsub(".txt", "", indexfilespoly[i])
  population.freq.table.poly[[i]][,2] = c("-", superpopnames[vectorpopsuperpop])
  population.freq.table.poly[[i]][,3] = rownames(X)
  population.freq.table.poly[[i]][,4] = rowSums(X)
  population.freq.table.poly[[i]][,5] = X[,1]
  population.freq.table.poly[[i]][,6] = X[,2]
  population.freq.table.poly[[i]][,7] = X[,3]
  population.freq.table.poly[[i]][,8] = HWExactMat(X)$pvalvec
  
  polytotaltable=cbind(polytotaltable, as.character(numtspaper2014[[i]]$heteralign))
  
}


population.freq.table.poly.full = population.freq.table.poly[[1]]
for (i in 2:length(population.freq.table.poly)) {
  
  population.freq.table.poly.full = rbind(population.freq.table.poly.full, population.freq.table.poly[[i]])
  
}
population.freq.table.poly.full = data.frame(population.freq.table.poly.full)


freqstablepoly=matrix(NA, nrow=26, ncol=23)
rownames(freqstablepoly) = unique(index1000genomes[,4]) 
colnames(freqstablepoly) = gsub(".txt", "", indexfilespoly)
counterpob=0
for (i in unique(index1000genomes[,4])) {
  counterpob=counterpob+1
  for (k in 3:25) {
    
    sumfreq=length(polytotaltable[which(polytotaltable[,2] == i & polytotaltable[,k] == "DI")])*0.5
    sumfreq=sumfreq+length(polytotaltable[which(polytotaltable[,2] == i & polytotaltable[,k] == "II")])
    sumfreq=sumfreq/length(polytotaltable[which(polytotaltable[,2] == i)])
    freqstablepoly[counterpob,k-2]=sumfreq
  }
  
  
  
}


require(FactoMineR)
PCA_Poly_NUMTS = PCA(freqstablepoly)

superpopnames = c("EAS", "EUR",  "AFR", "AMR", "SAS")
vectorpopsuperpop = c(2,2,1,4,1,4,2,4,5,1,3,3,3,5,3,5,5,2,3,1,1,3,3,4,2,5)
plot(PCA_Poly_NUMTS, col.ind=vectorpopsuperpop, title = "PCA for Poly NUMTs")



################################# END OF ANALYSIS OF Poly NUMTS #################################




################################# TABLES EXPORT #################################


population.freq.table.full = population.freq.table.full[order
                           (population.freq.table.full[,1],
                             population.freq.table.full[,2]),]

population.freq.table.poly.full = population.freq.table.poly.full[order
                           (population.freq.table.poly.full[,1],
                             population.freq.table.poly.full[,2]),]

WriteXLS::WriteXLS("population.freq.table.full", ExcelFileName = "S1_Table.xlsx")
WriteXLS::WriteXLS("population.freq.table.poly.full", ExcelFileName = "S1_Table.xlsx")


################################# END OF TABLES EXPORT #################################




########## LAST PCA ############

require(FactoMineR)
PCA_filtered_NUMTS = PCA(cbind(
  freqstablepoly[,c(20,23,3,7,5,9,10,8,11,13,14,15)],
  freqstable[,1:7]
  ))

plot(PCA_filtered_NUMTS, col.ind=vectorpopsuperpop, title = "PCA with selected NUMTs")


########## END OF LAST PCA ############

  