#!/bin/bash

numtname=( $(cut -d$'\t' -f1 ./polynumtsbash.txt | sed 's/*/ASTER/g') ); #NUMT name
#length=( $(cut -d$'\t' -f3 ./polynumtsbash.txt | sed 's/*/ASTER/g') ); #Extended length
numtlen=( $(cut -d$'\t' -f3 ./polynumtsbash.txt | sed 's/*/ASTER/g') ); #NUMT length
initial=( $(cut -d$'\t' -f4 ./polynumtsbash.txt | sed 's/*/ASTER/g') ); #NUMT initial pos
fin=( $(cut -d$'\t' -f5 ./polynumtsbash.txt | sed 's/*/ASTER/g') ); #NUMT end pos
extension=( $(cut -d$'\t' -f6 ./polynumtsbash.txt | sed 's/*/ASTER/g') ); #1000 or 3000



calc(){ awk "BEGIN { print "$*" }"; }

for k in "${!numtname[@]}"; do

echo -e "sample" ' \t ' "totalCoverage" ' \t ' "InitialOverlap" ' \t ' "EndOverlap" ' \t ' "NUMTcoverage" ' \t ' "CoverageProportion" ' \t ' "ReadsSupportingInsertion" ' \t ' "ReadsSuportingDeletion" ' \t ' "CheckedReads" ' \t ' "NUMTsino" ' \t ' "NUMTfail" > ./polyresults/"${numtname[k]}".txt;

halfextension=`calc ${extension[i]}/2`

numtinin=$((initial[k] - 5))
numtinendalign=$((initial[k] + 5))
numtinend=$((initial[k] + 10))
numtinin10=$((initial[k] - 10))

numtendinalign=$((fin[k] - 5))
numtendin=$((fin[k] - 10))
numtendend=$((fin[k] + 5))
numtendend10=$((fin[k] + 10))

restain=${initial[k]}
restafin=${fin[k]}

numtprotocoldelimin=$((initial[k] - 200))
numtprotocoldelimend=$((fin[k] + 200))

numtcovinitial=$((initial[k] - 1000))
numtcovend=$((fin[k] + 1000))


# Print titles and new text file

ls ./samples/${numtname[k]} | while read file; do


    breakpointoverlap=0;
    breakpointpresoft=0;
    breakpointpostsoft=0;
    mtmapped=0;

    preunmapped=0;
    postunmapped=0;
    premtmapped=0;
    postmtmapped=0;
    preotherchrommapped=0;
    postotherchrommapped=0;
    mtregionmapped=0;
    
    nuclearsimitosi=0;
    nuclearnomitono=0;
    nuclearsimitono=0;
    nuclearnomitosi=0;
    nuclearsiSOFTmitono=0;
    mitofullMATCH=0;
    mitofullSOFT=0;
    
    
    covtotal=0
    initialoverlap=0
    endoverlap=0
    coverint=0
    numtfail=0
    
    initialmateoverlap=0
    endmateoverlap=0
    matedischeckneg=0
    matedischeckpos=0
    
    warnings=0
    numtsi=0
    numtno=0
    checkedcounter=0
    
    unfilteredcov=0

    names=( $(cut -d$'\t' -f1 ./samples/${numtname[k]}/$file | sed 's/*/ASTER/g') )
    seqs=( $(cut -d$'\t' -f10 ./samples/${numtname[k]}/$file | sed 's/*/ASTER/g') )
    cigar=( $(cut -d$'\t' -f6 ./samples/${numtname[k]}/$file | sed 's/*/ASTER/g') )
    pos=( $(cut -d$'\t' -f4 ./samples/${numtname[k]}/$file | sed 's/*/ASTER/g') )
    matechr=( $(cut -d$'\t' -f7 ./samples/${numtname[k]}/$file | sed 's/*/ASTER/g' ) )
    matedis=( $(cut -d$'\t' -f9 ./samples/${numtname[k]}/$file | sed 's/*/ASTER/g') )
    matepos=( $(cut -d$'\t' -f8 ./samples/${numtname[k]}/$file | sed 's/*/ASTER/g') )

    
    
    
    readmeanlen=0
    readmeandis=0
    readcounter=0

    for i in "${!seqs[@]}"; do # Calculus of reads and distances mean length
    
            #len="${#seqs[i]}";
        
        if ( [ "${pos[i]}" -lt "$numtprotocoldelimin" ] || [ "${pos[i]}" -gt "$numtprotocoldelimend" ] ) && [ "${matedis[i]}" != 0  ] && [ "${matedis[i]}" -gt 0  ] && [ "${matedis[i]}" -lt 20000 ]; then
            #readmeanlen=$((readmeanlen + len));
            readmeandis=$((readmeandis + matedis[i]));
            let readcounter++;
        fi
        
    
    done
    readmeandis=`calc $readmeandis/$readcounter`;
    readmeandis=${readmeandis%%.*}
    halfreadmeadis=$((readmeandis / 2))
    
    doublereadmeandis=$((readmeandis * 2))
    predoublereadmeandis=$((initial[k] - doublereadmeandis))
    postdoublereadmeandis=$((fin[k] + doublereadmeandis))
    # End of calculus of reads and distances mean length
    
    
    
    
    
    for i in "${!seqs[@]}"; do
    
        len="${#seqs[i]}";
        posit="${pos[i]}";       
        unclippedstart="${pos[i]}";
        posfin=$((unclippedstart + len));
        unclippedend="$posfin";
        
        
        
        
        
        #if [ "${pos[i]}" -gt "$numtprotocoldelimin" ] || [ "${pos[i]}" -lt "$numtprotocoldelimend" ]; then  
        
        if [[ "${cigar[i]}" == *"S"* ]]; then
        
            scigar=($(tr "[0-9]" "\n" <<< "${cigar[i]}"));
            ncigar=($(tr "[A-Z]" "\n" <<< "${cigar[i]}"));
            
            if [ "${scigar[0]}" == "S" ]; then
            
                unclippedstart=$((pos[i] - ncigar[0]));
                posfin=$((unclippedstart + len));
                unclippedend="$posfin";
            
            fi
            
            
            
            if [ "${scigar[${#scigar[@]}-1]}" == "S" ]; then
                
                unclippedend=$((unclippedstart + len - ncigar[${#scigar[@]}-1]));
            
            fi


        fi
    
        
        if [ "$unclippedstart" -lt "$numtprotocoldelimin" ] && [ "$posfin" -gt "$numtcovinitial" ]; then 
        
            if [ "$unclippedstart" -gt "$numtcovinitial" ] && [ "$posfin" -lt "$numtprotocoldelimin" ]; then   
                covtotal=$((covtotal + len));
            fi
            
            if [ "$unclippedstart" -lt "$numtcovinitial" ] && [ "$posfin" -lt "$numtprotocoldelimin" ]; then
                difference=$((numtcovinitial - unclippedstart));
                covtotal=$((covtotal + len - difference));
            fi
            
            if [ "$unclippedstart" -gt "$numtcovinitial" ] && [ "$posfin" -gt "$numtprotocoldelimin" ]; then 
                difference=$((posfin - numtprotocoldelimin));
                covtotal=$((covtotal + len - difference));
            fi
        fi
        
        if [ "$posfin" -gt "$numtprotocoldelimend" ] && [ "$unclippedstart" -lt "$numtcovend" ]; then   

            if [ "$unclippedstart" -gt "$numtprotocoldelimend" ] && [ "$posfin" -lt "$numtcovend" ]; then   
                covtotal=$((covtotal + len));
            fi
            
            if [ "$unclippedstart" -lt "$numtprotocoldelimend" ] && [ "$posfin" -lt "$numtcovend" ]; then
                difference=$((numtprotocoldelimend - unclippedstart));
                covtotal=$((covtotal + len - difference));
            fi
            
            if [ "$unclippedstart" -gt "$numtprotocoldelimend" ] && [ "$posfin" -gt "$numtcovend" ]; then 
                difference=$((posfin - numtcovend));
                covtotal=$((covtotal + len - difference));
            fi
        fi
        
        
        
        ### Alignment part:
        if [[ ( "$unclippedstart" -lt "${initial[k]}" && "$posfin" -gt "${initial[k]}" ) || ( "$unclippedstart" -lt "${fin[k]}" && "$posfin" -gt "${fin[k]}" ) ]]; then  # Conditions to select those reads overlapping the NUMT insertion region
        
            havingS=0
            nothavingS=0
            numtfail=0
        
            let checkedcounter++;
            
            echo "${names[i]}";
            echo "$unclippedstart" "$posfin";
            
            echo -e ">" "hello" > input.txt;
            echo "${seqs[i]}" >> input.txt;
            #echo "hello"
            echo "$file";
            
            bwa mem ./polyreferenceGenomes/ref_"${numtname[k]}".txt input.txt | tail -n +3 > result.txt;
            newcigarNUCLEAR=( $(cut -d$'\t' -f6 ./result.txt | sed 's/*/K/g' ) )
            echo $newcigarNUCLEAR;
            
            bwa mem ./polyreferenceGenomes/ref_mt_"${numtname[k]}".txt input.txt | tail -n +3 > result.txt;
            newcigarMITO=( $(cut -d$'\t' -f6 ./result.txt | sed 's/*/K/g' ) )
            echo $newcigarMITO;
            
            bwa mem ./polyreferenceGenomes/refFULLMT.txt input.txt | tail -n +3 > result.txt;
            newcigarFULLMITO=( $(cut -d$'\t' -f6 ./result.txt | sed 's/*/K/g' ) )
            echo $newcigarFULLMITO;
            
            if [[ "$newcigarNUCLEAR" != "K" ]] && [[ "$newcigarMITO" == "K" ]] && [[ "$newcigarNUCLEAR" != *"S"* ]]; then                 
                 let nuclearsimitono++;            
            fi   
            
            if [[ "$newcigarNUCLEAR" != "K" ]] && [[ "$newcigarMITO" == "K" ]] && [[ "$newcigarNUCLEAR" == *"S"* ]]; then                 
                 let nuclearsiSOFTmitono++;            
            fi 
            
            if [[ "$newcigarNUCLEAR" == "K" ]] && [[ "$newcigarMITO" != "K" ]]; then
                let nuclearnomitosi++;           
            fi
          
            if [[ "$newcigarNUCLEAR" != "K" ]] && [[ "$newcigarMITO" != "K" ]]; then
                let nuclearsimitosi++;           
            fi
            
            if [[ "$newcigarNUCLEAR" == "K" ]] && [[ "$newcigarMITO" == "K" ]]; then
                let nuclearnomitono++;           
            fi
            
            if [[ "$newcigarMITO" == "K" ]] && [[ "$newcigarFULLMITO" != "K" ]] && [[ "$newcigarFULLMITO" == *"S"* ]]; then
                let mitofullSOFT++;           
            fi
            
            if [[ "$newcigarMITO" == "K" ]] && [[ "$newcigarFULLMITO" != "K" ]] && [[ "$newcigarFULLMITO" != *"S"* ]]; then
                let mitofullMATCH++;           
            fi


        fi
        
        ##### End of alignment part
    
    
    
        if [ ${pos[i]} -lt $numtinin ] && [ $unclippedend -gt $numtendend ]; then
    
    
            let breakpointoverlap++;
        
    
        fi
    
    
    
    
    
        if [ $unclippedend -lt $numtinin10 ] && [ $posfin -gt $numtinin ]  && [ ${matedis[i]} -lt "0" ]; then
    
    
            let breakpointpresoft++;
        
    
        fi
    
    
        if [ ${pos[i]} -gt $numtendend10 ] && [ $unclippedstart -lt $numtendend ] && [ ${matedis[i]} -gt "0" ]; then
    
    
            let breakpointpostsoft++;
        
    
        fi
        
        
        if [ ${pos[i]} -gt $predoublereadmeandis ] && [ $unclippedend -lt ${initial[k]} ] && [ ${matechr[i]} == "ASTER" ]; then
        
            let preunmapped++;
        
        fi
        
        if [ $unclippedend -lt $postdoublereadmeandis ] && [ ${pos[i]} -gt ${fin[k]} ] && [ ${matechr[i]} == "ASTER" ]; then
        
            let postunmapped++;
        
        fi
        
        if [ ${pos[i]} -gt $predoublereadmeandis ] && [ $unclippedend -lt ${initial[k]} ] && [ ${matechr[i]} == "MT" ]; then
        
            let premtmapped++;
        
        fi
        
        if [ $unclippedend -lt $postdoublereadmeandis ] && [ ${pos[i]} -gt ${fin[k]} ] && [ ${matechr[i]} == "MT" ]; then
        
            let postmtmapped++;
        
        fi
        
        if [ $unclippedend -gt $predoublereadmeandis ] && [ ${pos[i]} -lt $postdoublereadmeandis ] && [ ${matechr[i]} == "MT" ]; then
        
            let mtregionmapped++;
        
        fi
        
        if [ ${pos[i]} -gt $predoublereadmeandis ] && [ $unclippedend -lt ${initial[k]} ] && [ ${matechr[i]} != "=" ] && [ ${matechr[i]} != "MT" ] && [ ${matechr[i]} != "ASTER" ]; then
        
            let preotherchrommapped++;
        
        fi
        
        if [ $unclippedend -lt $postdoublereadmeandis ] && [ ${pos[i]} -gt ${fin[k]} ] && [ ${matechr[i]} != "=" ] && [ ${matechr[i]} != "MT" ] && [ ${matechr[i]} != "ASTER" ]; then
        
            let postotherchrommapped++;
        
        fi
        
        if [ ${matechr[i]} == "MT" ]; then
        
            let mtmapped++;
        
        fi
        
    #fi    
    
    done
    
    
    #extensionext=$((extension - 200));
    covextension=1600;
    covtotaldivided=`calc $covtotal/$covextension`;
    
    echo -e $file ' \t ' $covtotaldivided ' \t ' $breakpointoverlap ' \t ' $breakpointpresoft ' \t ' $breakpointpostsoft ' \t ' $preunmapped ' \t ' $postunmapped ' \t ' $premtmapped ' \t ' $postmtmapped ' \t ' $preotherchrommapped ' \t ' $postotherchrommapped ' \t ' $mtmapped ' \t ' $nuclearsimitono ' \t ' $nuclearsiSOFTmitono ' \t ' $nuclearnomitosi ' \t ' $nuclearsimitosi ' \t ' $nuclearnomitono ' \t ' $mitofullMATCH  ' \t ' $mitofullSOFT ' \t ' $mtregionmapped >> ./polyresults/"${numtname[k]}".txt;

    done
    
    
done