#!/bin/bash


numtname=( $(cut -d$'\t' -f1 numtsbash.txt ) )
extcoordinates=( $(cut -d$'\t' -f2 numtsbash.txt ) )
length=( $(cut -d$'\t' -f3 numtsbash.txt ) )

numtorigin=( $(cut -d$'\t' -f4 numtsbash.txt ) )
numtend=( $(cut -d$'\t' -f5 numtsbash.txt ) )


for i in "${!numtname[@]}"; do
    
    chromosome="${extcoordinates[i]}";
    samtools faidx human_g1k_v37.fasta "${extcoordinates[i]}" > ./referenceGenomes/ref_"${numtname[i]}".txt;
    
    
    
    nonumtinin=`sed 's/.*:\(.*\)-.*/\1/' <<< "$chromosome"`;
    nonumtendend=`sed -e 's#.*-\(\)#\1#' <<< "$chromosome"`;
    
    nonumtinend=$((numtorigin[i] - 1));
    nonumtendin=$((numtend[i] + 1));
    samtools faidx human_g1k_v37.fasta ${chromosome%%:*}:"$nonumtinin"-"$nonumtinend" > ./referenceGenomes/ref_nonumt_1_"${numtname[i]}".txt;
    samtools faidx human_g1k_v37.fasta ${chromosome%%:*}:"$nonumtendin"-"$nonumtendend" > ./referenceGenomes/ref_nonumt_2_"${numtname[i]}".txt;
    
    firstpart=`cat ./referenceGenomes/ref_nonumt_1_"${numtname[i]}".txt`;
    secondpart=`tail -n +2 ./referenceGenomes/ref_nonumt_2_"${numtname[i]}".txt`;
    
    echo -e "$firstpart"'\n'"$secondpart" > ./referenceGenomes/ref_nonumt_"${numtname[i]}".txt;
    
    bwa index ./referenceGenomes/ref_"${numtname[i]}".txt;
    bwa index ./referenceGenomes/ref_nonumt_"${numtname[i]}".txt;
    
done

