#!/bin/bash

numtname=( $(cut -d$'\t' -f1 ./numtsbash.txt | sed 's/*/ASTER/g') ); #NUMT name
#length=( $(cut -d$'\t' -f3 ./numtsbash.txt | sed 's/*/ASTER/g') ); #Extended length
numtlen=( $(cut -d$'\t' -f3 ./numtsbash.txt | sed 's/*/ASTER/g') ); #NUMT length
initial=( $(cut -d$'\t' -f4 ./numtsbash.txt | sed 's/*/ASTER/g') ); #NUMT initial pos
fin=( $(cut -d$'\t' -f5 ./numtsbash.txt | sed 's/*/ASTER/g') ); #NUMT end pos
extension=( $(cut -d$'\t' -f6 ./numtsbash.txt | sed 's/*/ASTER/g') ); #1000 or 3000



calc(){ awk "BEGIN { print "$*" }"; }

for k in "${!numtname[@]}"; do

echo -e "sample" ' \t ' "totalCoverage" ' \t ' "InitialOverlap" ' \t ' "EndOverlap" ' \t ' "NUMTcoverage" ' \t ' "CoverageProportion" ' \t ' "ReadsSupportingInsertion" ' \t ' "ReadsSuportingDeletion" ' \t ' "CheckedReads" ' \t ' "NUMTsino" ' \t ' "NUMTfail" > ./results/"${numtname[k]}".txt;

halfextension=`calc ${extension[i]}/2`

numtinin=$((initial[k] - 5))
numtinendalign=$((initial[k] + 5))
numtinend=$((initial[k] + 10))

numtendinalign=$((fin[k] - 5))
numtendin=$((fin[k] - 10))
numtendend=$((fin[k] + 5))

restain=${initial[k]}
restafin=${fin[k]}

numtprotocoldelimin=$((initial[k] - 300))
numtprotocoldelimend=$((fin[k] + 200))


# Print titles and new text file

ls ./samples/${numtname[k]} | while read file; do

    covtotal=0
    initialoverlap=0
    endoverlap=0
    coverint=0
    numtfail=0
    
    initialmateoverlap=0
    endmateoverlap=0
    matedischeckneg=0
    matedischeckpos=0
    
    warnings=0
    numtsi=0
    numtno=0
    checkedcounter=0
    
    unfilteredcov=0

    names=( $(cut -d$'\t' -f1 ./samples/${numtname[k]}/$file | sed 's/*/ASTER/g') )
    seqs=( $(cut -d$'\t' -f10 ./samples/${numtname[k]}/$file | sed 's/*/ASTER/g') )
    cigar=( $(cut -d$'\t' -f6 ./samples/${numtname[k]}/$file | sed 's/*/ASTER/g') )
    pos=( $(cut -d$'\t' -f4 ./samples/${numtname[k]}/$file | sed 's/*/ASTER/g') )
    matechr=( $(cut -d$'\t' -f7 ./samples/${numtname[k]}/$file | sed 's/*/ASTER/g' ) )
    matedis=( $(cut -d$'\t' -f9 ./samples/${numtname[k]}/$file | sed 's/*/ASTER/g') )
    matepos=( $(cut -d$'\t' -f8 ./samples/${numtname[k]}/$file | sed 's/*/ASTER/g') )

    readmeanlen=0
    readmeandis=0
    readcounter=0

    for i in "${!seqs[@]}"; do # Calculus of reads and distances mean length
    
            #len="${#seqs[i]}";
        
        if ( [ "${pos[i]}" -lt "$numtprotocoldelimin" ] || [ "${pos[i]}" -gt "$numtprotocoldelimend" ] ) && [ "${matedis[i]}" != 0  ] && [ "${matedis[i]}" -gt 0  ] && [ "${matedis[i]}" -lt 20000 ]; then
            #readmeanlen=$((readmeanlen + len));
            readmeandis=$((readmeandis + matedis[i]));
            let readcounter++;
        fi
        
    
    done
    readmeandis=`calc $readmeandis/$readcounter`;
    readmeandis=${readmeandis%%.*}
    halfreadmeadis=$((readmeandis / 2))
    # End of calculus of reads and distances mean length



# Protocol for NUMTs length lower than (distmates - 40):
if [ ${numtlen[k]} -lt $readmeandis  ] || [ "${numtlen[k]}" == "$readmeandis" ]; then


for i in "${!seqs[@]}"; do
    
    
    
        len="${#seqs[i]}";
        posit="${pos[i]}";       
        unclippedstart="${pos[i]}";
        posfin=$((unclippedstart + len));
        unclippedend="$posfin";
        
        
        if [[ "${cigar[i]}" == *"S"* ]]; then
        
            scigar=($(tr "[0-9]" "\n" <<< "${cigar[i]}"));
            ncigar=($(tr "[A-Z]" "\n" <<< "${cigar[i]}"));
            
            if [ "${scigar[0]}" == "S" ]; then
            
                unclippedstart=$((pos[i] - ncigar[0]));
                posfin=$((unclippedstart + len));
                unclippedend="$posfin";
            
            fi
            
            
            
            if [ "${scigar[${#scigar[@]}-1]}" == "S" ]; then
                
                unclippedend=$((unclippedstart + len - ncigar[${#scigar[@]}-1]));
            
            fi


       fi
        

     if [ "${pos[i]}" -gt "$initial" ] && [ "$unclippedend" -lt "$fin" ]; then
        unfilteredcov=$((unfilteredcov + unclippedend - pos[i]));
     fi
    if [ "${pos[i]}" -lt "$initial" ] && [ "$unclippedend" -gt "$fin" ]; then
        unfilteredcov=$((unfilteredcov + fin - initial));
     fi
    if [ "${pos[i]}" -lt "$initial" ] && [ "$unclippedend" -lt "$fin" ]; then
        unfilteredcov=$((unfilteredcov + unclippedend - initial));
     fi
    if [ "${pos[i]}" -gt "$initial" ] && [ "$unclippedend" -gt "$fin" ]; then
        unfilteredcov=$((unfilteredcov + fin - pos[i]));
     fi
     
    if [ "${matechr[i]}" == "=" ] && [ "${matedis[i]}" != 0 ] && [ "${matedis[i]}" -lt 20000 ] && [ "${matedis[i]}" -gt -20000 ]; then #Conditions to filter mtDNA

        
        if [ "${pos[i]}" -lt "$numtprotocoldelimin" ] || [ "${pos[i]}" -gt "$numtprotocoldelimend" ]; then 
            covtotal=$((covtotal + len));
        fi
        
        if [[ ( "$unclippedstart" -lt "$numtinin"  &&  "$posfin" -gt "$numtinendalign" ) || ( "$unclippedstart" -lt "$numtendinalign"  &&  "$posfin" -gt "$numtendend" ) ]]; then  # Conditions to select those reads overlapping the NUMT insertion region
        
        havingS=0
        nothavingS=0

        
        let checkedcounter++;
            
            echo "${names[i]}";
            echo "$unclippedstart" "$posfin";
            
            echo -e ">" "hello" > input.txt;
            echo "${seqs[i]}" >> input.txt;
            #echo "hello"
            echo "$file";
            
            bwa mem ./referenceGenomes/ref_"${numtname[k]}".txt input.txt | tail -n +3 > result.txt;
            newcigar=( $(cut -d$'\t' -f6 ./result.txt | sed 's/*/K/g' ) )
            echo $newcigar;
            
            if [[ "$newcigar" == *"S"* ]] || [[ "$newcigar" == "K" ]]; then                 
                 let numtno++;
                 let havingS++;
            
            else
            
                 let numtsi++;
                 let nothavingS++;
            fi   
      
            bwa mem ./referenceGenomes/ref_nonumt_"${numtname[k]}".txt input.txt | tail -n +3 > result.txt;
            newcigar=( $(cut -d$'\t' -f6 ./result.txt | sed 's/*/K/g' ) )
            #echo $newcigar;
            
            if [[ "$newcigar" == *"S"* ]] || [[ "$newcigar" == "K" ]]; then
                 let numtsi++;
                 let havingS++;
            
            else
            
                 let numtno++;
                 let nothavingS++;
            fi    
            
            if [[ "$newcigar" == *"D"* ]] || [[ "$newcigar" == *"I"* ]]; then
                let warnings++;
            fi
            
            echo ${newcigar[@]};
            echo $nothavingS;
            echo $havingS;
            
            if [ "$nothavingS" -gt "1" ] || [ "$havingS" -gt "1" ]; then
                numtno=$((numtno - 1));
                numtsi=$((numtsi - 1));
                numtfail=$((numtfail + 1));
                
            fi
            
            #bwa mem refnonumt.txt heterozg2.txt
            #echo "${cigar[i]}";
            
            #echo $covtotal;
            #echo $i;
            #totlen=`expr "$len"+"$totlen"`
            #b=`gawk '{print $10;}' ./$1/$file  | wc -m`
            #c=`calc $a/2000`
            #d=`calc $b/2000`
    
            #echo -e $file' \t ' $c ' \t ' $d;
        
            #>> coverage10.txt;
        echo $numtno;
        fi
        
       if [ "${pos[i]}" -lt "$numtinin" ] && [ "$unclippedend" -gt "$numtinend" ] && [[ "${cigar[i]}" != *"D"* ]]; then #Conditions to select those reads overlapping the NUMT insertion region
        
            let initialoverlap++;
            
            #echo "${cigar[i]}";
            
            #echo $covtotal;
            #echo $i;
            #totlen=`expr "$len"+"$totlen"`
            #b=`gawk '{print $10;}' ./$1/$file  | wc -m`
            #c=`calc $a/2000`
            #d=`calc $b/2000`
    
            #echo -e $file' \t ' $c ' \t ' $d;
        
            #>> coverage10.txt;
    
        fi
        
         if [ "${pos[i]}" -lt "$numtendin" ] && [ "$unclippedend" -gt "$numtendend" ] && [[ "${cigar[i]}" != *"D"* ]]; then 
         

         let endoverlap++;
         
         fi
    
        if [ "${pos[i]}" -lt "$restain" ] && [ "$unclippedend" -gt "$restain" ] && [ "$unclippedend" -lt "$restafin" ] && [[ "${cigar[i]}" != *"D"* ]]; then 
         
        echo "${cigar[i]}";
        lenint=$((unclippedend - restain));
        coverint=$((coverint + lenint));
         
         fi
         
         if [ "${pos[i]}" -gt "$restain"  ] && [ "${pos[i]}" -lt "$restafin" ] && [ "$unclippedend" -gt "$restafin" ] && [[ "${cigar[i]}" != *"D"* ]]; then 
         
         #echo "${cigar[i]}";
         lenint=$((restafin - pos[i]));
         coverint=$((coverint + lenint));
         
         fi
         
         if [ "${pos[i]}" -gt "$restain"  ] && [ "$unclippedend" -lt "$restafin" ] && [[ "${cigar[i]}" != *"S"* ]] && [[ "${cigar[i]}" != *"D"* ]]; then 
         
         coverint=$((coverint + unclippedend - pos[i]));
         
         fi

         if [ "${pos[i]}" -lt "$restain"  ] && [ "$unclippedend" -gt "$restafin" ] && [[ "${cigar[i]}" != *"D"* ]]; then 
         
         coverint=$((coverint + numtlen[k]));
         
         fi 
        
        
    fi
    
    
done    
    
    extensionext=$((extension * 2));
    extensionext=$((extensionext - 500));
    covtotaldivided=`calc $covtotal/$extensionext`;
    coverint=`calc $coverint/${numtlen[k]}`;
    prop=`calc $coverint/$covtotaldivided`;
    unfilteredcov=$((unfilteredcov / numtlen[k]));
        
    numtno=`calc $numtno/2`
    numtsi=`calc $numtsi/2` 
    sumnumtsino=$((numtsi + numtno));
    #echo -e $file ' \t ' $totlen >> coverage20.txt;
    




    # Print individual output line:
    echo -e $file ' \t ' "0" ' \t ' $covtotaldivided ' \t ' $initialoverlap ' \t ' $endoverlap ' \t ' $coverint ' \t ' $prop ' \t ' $numtsi ' \t ' $numtno ' \t ' $checkedcounter ' \t ' $sumnumtsino ' \t ' $numtfail ' \t ' $warnings >> ./results/"${numtname[k]}".txt;

fi
# End of protocol for NUMTs length lower than (distmates - 40)




# Protocol for NUMTs length greater than (distmates - 40):
if [ ${numtlen[k]} -gt $readmeandis ]; then


for i in "${!seqs[@]}"; do        
    
        len="${#seqs[i]}";
        posit="${pos[i]}";       
        unclippedstart="${pos[i]}";
        posfin=$((unclippedstart + len));
        unclippedend="$posfin";
        
        
        if [[ "${cigar[i]}" == *"S"* ]]; then
        
            scigar=($(tr "[0-9]" "\n" <<< "${cigar[i]}"));
            ncigar=($(tr "[A-Z]" "\n" <<< "${cigar[i]}"));
            
            if [ "${scigar[0]}" == "S" ]; then
            
                unclippedstart=$((pos[i] - ncigar[0]));
                posfin=$((unclippedstart + len));
                unclippedend="$posfin";
            
            fi
            
            
            
            if [ "${scigar[${#scigar[@]}-1]}" == "S" ]; then
                
                unclippedend=$((unclippedstart + len - ncigar[${#scigar[@]}-1]));
            
            fi


       fi
    
    
     if [ "${pos[i]}" -gt "$initial" ] && [ "$unclippedend" -lt "$fin" ]; then
        unfilteredcov=$((unfilteredcov + unclippedend - pos[i]));
     fi
    if [ "${pos[i]}" -lt "$initial" ] && [ "$unclippedend" -gt "$fin" ]; then
        unfilteredcov=$((unfilteredcov + numtendend - initial));
     fi
    if [ "${pos[i]}" -lt "$initial" ] && [ "$unclippedend" -lt "$fin" ]; then
        unfilteredcov=$((unfilteredcov + unclippedend - initial));
     fi
    if [ "${pos[i]}" -gt "$initial" ] && [ "$unclippedend" -gt "$fin" ]; then
        unfilteredcov=$((unfilteredcov + fin - pos[i]));
     fi
    
    
    if [ "${matechr[i]}" == "=" ] && [ "${matedis[i]}" != 0 ] && [ "${matedis[i]}" -lt 20000 ] && [ "${matedis[i]}" -gt -20000 ]; then #Conditions to filter mtDNA
    
    
        if [ "${pos[i]}" -lt "$numtprotocoldelimin" ] || [ "${pos[i]}" -gt "$numtprotocoldelimend" ]; then   
        covtotal=$((covtotal + len));
        fi
        
        if [[ ( "$unclippedstart" -lt "$numtinin"  &&  "$posfin" -gt "$numtinendalign" ) || ( "$unclippedstart" -lt "$numtendinalign"  &&  "$posfin" -gt "$numtendend" ) ]]; then  # Conditions to select those reads overlapping the NUMT insertion region
        
        havingS=0
        nothavingS=0
        numtfail=0
        
        let checkedcounter++;
            
            echo "${names[i]}";
            echo "$unclippedstart" "$posfin";
            
            echo -e ">" "hello" > input.txt;
            echo "${seqs[i]}" >> input.txt;
            #echo "hello"
            echo "$file";
            
            bwa mem ./referenceGenomes/ref_"${numtname[k]}".txt input.txt | tail -n +3 > result.txt;
            newcigar=( $(cut -d$'\t' -f6 ./result.txt | sed 's/*/K/g' ) )
            echo $newcigar;
            
            if [[ "$newcigar" == *"S"* ]] || [[ "$newcigar" == "K" ]]; then                 
                 let numtno++;
                 let havingS++;
            
            else
            
                 let numtsi++;
                 let nothavingS++;
            fi   
      
            bwa mem ./referenceGenomes/ref_nonumt_"${numtname[k]}".txt input.txt | tail -n +3 > result.txt;
            newcigar=( $(cut -d$'\t' -f6 ./result.txt | sed 's/*/K/g' ) )
            #echo $newcigar;
            
            if [[ "$newcigar" == *"S"* ]] || [[ "$newcigar" == "K" ]]; then
                 let numtsi++;
                 let havingS++;
            
            else
            
                 let numtno++;
                 let nothavingS++;
            fi    
            
            if [[ "$newcigar" == *"D"* ]] || [[ "$newcigar" == *"I"* ]]; then
                let warnings++;
            fi
            
            echo ${newcigar[@]};
            echo $nothavingS;
            echo $havingS;
            
            if [ "$nothavingS" -gt "1" ] || [ "$havingS" -gt "1" ]; then
                numtno=$((numtno - 1));
                numtsi=$((numtsi - 1));
                numtfail=$((numtfail + 1));
                
            fi
            
            #bwa mem refnonumt.txt heterozg2.txt
            #echo "${cigar[i]}";
            
            #echo $covtotal;
            #echo $i;
            #totlen=`expr "$len"+"$totlen"`
            #b=`gawk '{print $10;}' ./$1/$file  | wc -m`
            #c=`calc $a/2000`
            #d=`calc $b/2000`
    
            #echo -e $file' \t ' $c ' \t ' $d;
        
            #>> coverage10.txt;
        echo $numtno;
        fi
        
       
       if [ "${pos[i]}" -lt "$numtinin" ] && [ "$unclippedend" -gt "$numtinend" ] && [[ "${cigar[i]}" != *"D"* ]]; then #Conditions to select those reads overlapping the NUMT insertion region
        
            let initialoverlap++;
            
            #echo "${cigar[i]}";
            
            #echo $covtotal;
            #echo $i;
            #totlen=`expr "$len"+"$totlen"`
            #b=`gawk '{print $10;}' ./$1/$file  | wc -m`
            #c=`calc $a/2000`
            #d=`calc $b/2000`
    
            #echo -e $file' \t ' $c ' \t ' $d;
        
            #>> coverage10.txt;
    
        fi
        
         if [ "${pos[i]}" -lt "$numtendin" ] && [ "$unclippedend" -gt "$numtendend" ] && [[ "${cigar[i]}" != *"D"* ]]; then 
         

         let endoverlap++;
         
         fi
    
    matecheck=$((matepos[i] + len))
    if [ "${pos[i]}" -gt "$numtinend" ] && [ "${pos[i]}" -lt "$numtendin" ] && [ "$unclippedend" -lt "$numtendin" ] && [ "$unclippedend" -gt "$numtinend" ] && [ "$matecheck" -lt "$numtinin" ]; then 
        
        let initialmateoverlap++;
         
    fi 
    
    if [ "$unclippedend" -lt "$numtendin" ] && [ "$unclippedend" -gt "$numtinend" ] && [ "${pos[i]}" -gt "$numtinend" ] && [ "${pos[i]}" -lt "$numtendin" ] && [ "${matepos[i]}" -gt "$numtendend" ]; then 
        
        let endmateoverlap++;        
         
    fi 
    
    if [ "$matecheck" -lt "$numtinin" ] && [ "${pos[i]}" -gt "$numtendend" ]; then 
        

        negativecheck=$((0 - readmeandis - halfreadmeadis))
        if [ "${matedis[i]}" -lt $negativecheck ]; then
            
            let matedischeckneg++;
            
        fi
    fi
        
        if [ "$unclippedend" -lt "$numtinin" ] && [ "${matepos[i]}" -gt "$numtendend" ]; then
            
            positivecheck=$((readmeandis + halfreadmeadis))
            if [ "${matedis[i]}" -gt $positivecheck ]; then
            let matedischeckpos++;
            fi
        fi
        
    
        
        
    fi
    
    
done    

    extensionext=$((extension * 2));
    extensionext=$((extensionext - 500));
    covtotaldivided=`calc $covtotal/$extensionext`;
    unfilteredcov=$((unfilteredcov / numtlen[k]));
    #coverint=`calc $coverint/1021`;
    #prop=`calc $coverint/$covtotaldivided`;
    
    numtno=`calc $numtno/2`
    numtsi=`calc $numtsi/2` 
    sumnumtsino=$((numtsi + numtno));
    #echo -e $file ' \t ' $totlen >> coverage20.txt;
    

    # Print individual output line:
    echo -e $file ' \t ' "1" ' \t ' $covtotaldivided ' \t ' $initialoverlap ' \t ' $endoverlap ' \t ' $initialmateoverlap ' \t ' $endmateoverlap ' \t ' $matedischeckneg ' \t ' $matedischeckpos ' \t '  $numtsi ' \t ' $numtno ' \t ' $checkedcounter ' \t ' $sumnumtsino ' \t ' $numtfail ' \t ' $warnings >> ./results/"${numtname[k]}".txt;

fi
    # Print individual output line
# End of protocol for NUMTs length greater than (distmates - 40)




done # END OF OPERATIONS PER INDIVIDUAL

done # END OF OPERATIONS PER NUMT